/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Preferences Toolbar 2.
 *
 * The Initial Developer of the Original Code is
 * Aaron Andersen.
 * Portions created by the Initial Developer are Copyright (C) 2___
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Aaron Andersen <aaron@xulplanet.com>
 *                 Manuel Reimer <Manuel.Reimer@gmx.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var RDF = goPrefBar.RDF.RDFService;
var myDatasource = goPrefBar.RDF.mDatasource;

function checkId(itemId)
{

	var RselItem = RDF.GetResource("urn:prefbar:buttons:" + itemId);

	var properties = myDatasource.ArcLabelsOut(RselItem);


	if(properties.hasMoreElements())
	{
		alert(prefbarGetString("newItemStrings", "alertidinuse"));

		return false;
	}
	else
	{
		return true;
	}
}

function attributeNotEmpty(label, edit)
{
	if(fieldEmpty(edit))
	{
		alert(goPrefBar.GetString("newItemStrings", "alertnovalue").replace("$label", label));

		return false;
	}
	else
	{
		return true;
	}
}

function fieldEmpty(edit)
{
	return document.getElementById(edit).value == "";	
}

function getItemLiteral(fieldId, multiline)
{
	var value = document.getElementById(fieldId).value;

	if (multiline != undefined && multiline == true)
		value = prefbarMulti2Single(value);

	return RDF.GetLiteral(value);
}

function setIdField(itemId)
{
	var itemIdShow = itemId.replace(/urn\:prefbar\:buttons:/g, "");

	var itemIdField = document.getElementById("itemId");

	itemIdField.value = itemIdShow
	itemIdField.disabled = "true";
}

function setField(itemId, attribute,  fieldId, multiline)
{
	var RitemId = RDF.GetResource(itemId);
	var Rattribute = RDF.GetResource("http://www.xulplanet.com/rdf/prefbar#" + attribute);

	var Nvalue = myDatasource.GetTarget(RitemId, Rattribute, true);
	if (!Nvalue) return;
	var value = Nvalue.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

	if (multiline != undefined && multiline == true)
		value = prefbarSingle2Multi(value);

	document.getElementById(fieldId).value = value;

}

function editField(itemId, attribute, fieldId, multiline)
{
	// Get Data
	var RitemId = RDF.GetResource(itemId);
	var Rattribute = RDF.GetResource("http://www.xulplanet.com/rdf/prefbar#" + attribute);

	var NoldValue = myDatasource.GetTarget(RitemId, Rattribute, true);
	var LnewValue = getItemLiteral(fieldId, multiline);

	// Change RDF
	myDatasource.Change(RitemId, Rattribute, NoldValue, LnewValue);  
}

function removeField(itemId, attribute, fieldId)
{
	// Get Data
	var RitemId = RDF.GetResource(itemId);
	var Rattribute = RDF.GetResource("http://www.xulplanet.com/rdf/prefbar#" + attribute);


	if(myDatasource.hasArcOut(RitemId, Rattribute))
	{
		var NoldValue = myDatasource.GetTarget(RitemId, Rattribute, true);

		// Remove Old Data
		myDatasource.Unassert(RitemId, Rattribute, NoldValue, true);
		return true;
	} else return false;
}









